// niles2bin.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <stdlib.h>

// Function Prototypes

int main(int argc, char* argv[]);
int GetDigit(CHAR ch);
BOOL Niles2Bin(PTSTR pszFilenameIn, PTSTR pszFilenameOut);

/////////////////////////////////////////////////////////////////////////////
// Program Main

int main(int argc, char* argv[])
{
    if (argc != 3)
    {
        _tprintf(_T("\nusage: niles2bin <input-filename> <output-filename>\n\n"));
        return 1;
    }

    _tprintf(_T("NILES2BIN - ASCII Hex to Binary Convertor - v1.01\n"));
    _tprintf(_T("Copyright (C) 2002-2004, Robert E Starr - KG4LNE\n\n"));

    if (Niles2Bin(argv[argc-2], argv[argc-1]))
    {
        _tprintf(_T("\nDone...\n"));
    }

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// Hex Conversion Function

int GetDigit(CHAR ch)
{
    if (ch >= '0' && ch <= '9')
        return(ch - '0');
    if (ch >= 'a' && ch <= 'f')
        return(ch - 'a' + 10);
    if (ch >= 'A' && ch <= 'F')
        return(ch - 'A' + 10);
    return(0);
}

/////////////////////////////////////////////////////////////////////////////
// NILES Hex File Import/Export Helpers

BOOL Niles2Bin(PTSTR pszFilenameIn, PTSTR pszFilenameOut)
{
    FILE* fp_in;
    FILE* fp_out;

    if ((fp_in = fopen(pszFilenameIn, _T("r"))) == NULL)
    {
        _tprintf(_T("\nError: file '%s' open failed!\n"), pszFilenameIn);
        return FALSE;
    }

    if ((fp_out = fopen(pszFilenameOut, _T("wb"))) == NULL)
    {
        _tprintf(_T("\nError: file '%s' create failed!"), pszFilenameOut);
        fclose(fp_in);
        return FALSE;
    }

    UINT addr = 0;

	while (!feof(fp_in) && !ferror(fp_in))
    {
        CHAR    szBuf[8];
		BYTE	data;
        size_t  nRead;

        _tprintf(_T("\rWriting : %-4.4X"), addr);

        if ((nRead = fread(szBuf, sizeof(char), 2, fp_in)) != 2)
	        break;

		data = 16 * GetDigit(szBuf[0]) + GetDigit(szBuf[1]);

        if (fwrite(&data, sizeof(char), 1, fp_out) != 1)
        {
            _tprintf(_T("\n\nError: file write failed!"));
            break;
        }

		if (++addr >= 1024)
            break;
    }

    _tprintf(_T("\n"));

    fclose(fp_in);
    fclose(fp_out);
    
    return TRUE;
}

// end-of-file